/*
 * fault_filter.h
 *
 *  Created on: 2024年11月12日
 *      Author: 13168
 */

#ifndef ACTION_IMPL_FAULT_FILTER_H_
#define ACTION_IMPL_FAULT_FILTER_H_

#include <string>
#include "../../common/Type.h"
#include "../../servicemodel/Device.h"

#include "../../action/FaultRecorder.h"

class data_attribute
{
public:
    std::string device_name;           // 设备名称
    std::string name;           // 采集点名称
    std::string id;             // ID
    std::string value;          // 值
    // 默认构造函数
    data_attribute() : device_name(""), name(""), id(""), value("") {}
    // 构造函数
    data_attribute(std::string dev_namex, const std::string& namex, std::string idx, std::string val) : device_name(dev_namex), name(namex), id(idx), value(val){}

    virtual ~data_attribute()
    {
    }
};

class data_item
{
public:
    int number;
    std::vector<data_attribute> source_pitem;
    std::vector<data_attribute> fault_pitem;

    void add_source_item(std::string device_name, const std::string& name, std::string id, std::string value) {
        data_attribute newItem(device_name, name, id, value);
        source_pitem.push_back(newItem);  // 使用 push_back 方法新增元素
    }

    void add_fault_item(std::string device_name, const std::string& name, std::string id, std::string value) {
        data_attribute newfItem(device_name, name, id, value);
        fault_pitem.push_back(newfItem);  // 使用 push_back 方法新增元素
    }

    virtual ~data_item()
    {
    }
};

class ProtocolImpl: public ProtocolI_Fault
{
public:
    /*故障滤波*/
     virtual HRESULT set_fault_list(std::vector<Device*> data_list);

     HRESULT fault_filter(
        data_item* fault_type,            //触发故障的源类型
        data_item* source_data,            //源数据
        int save_time_before,             //保存故障发生前的数据时间
        int save_time_after               //保存故障发生后的数据时间
    );

    int fault_count;
    int fault_number_back;
    int back_fault_count;
    std::string back_fault_id;
    std::string back_file_name;
    std::string back_fault_file_name;
    double time_difference;
    //std::chrono::steady_clock::time_point back_time;
    long long back_time;
    long long fault_save_time_begin;

    ~ProtocolImpl()
    {
    }
};

#endif /* ACTION_IMPL_FAULT_FILTER_H_ */
