/*
 * DAControlerI.h DAControler接口定义头文件
 *
 *  Created on: 2016年12月14日
 *      Author: nego
 */

#ifndef ACTION_DACONTROLERI_H_
#define ACTION_DACONTROLERI_H_

#include <vector>

#include "../common/IUnknown.h"
#include "../common/Type.h"
#include "../servicemodel/Base.h"
#include "../servicemodel/Device.h"

interface DAControlerI: public IUnknown {
public:
	enum TYPE{
		CHANNEL = 0,
		DEVICE,
		PACKET,
		ITEM
	};

	virtual ~DAControlerI(){}

	/**
	 * DAControler控制接口
	 */
	virtual HRESULT init() = 0;	//----初始化DA
	virtual HRESULT start() = 0;	//----启动DA
	virtual HRESULT stop() = 0;	//----停止DA
	virtual HRESULT hang() = 0;	//----挂起DA
	virtual HRESULT resume() = 0;	//----恢复DA

	/**
	 * DAControler_Channel\Device\Packet\Item控制
	 */
	virtual HRESULT restart(CLSID& clsid,TYPE type) = 0;	//----重启
	virtual HRESULT stop(CLSID& clsid,TYPE type) = 0;	//----停止
	virtual HRESULT hang(CLSID& clsid,TYPE type) = 0;	//----挂起
	virtual HRESULT resume(CLSID& clsid,TYPE type) = 0;	//----恢复

	/**
	 * 动态监视
	 */
	virtual HRESULT dynamicIncreaseDevice(Device& device, bool iseffect) = 0;	//----动态增加设备
	//virtual HRESULT dynamicModifyPara(Device& device, std::string name, int value) = 0;	//----动态修改设备参数

	/**
	 * 性能监视
	 */
	virtual Base::QUALITY getQuality(CLSID& clsid,TYPE type) = 0;	//----获取采集质量
	virtual ULONG getReadCount(CLSID& clsid,TYPE type) = 0;	//----获取读计数
	virtual ULONG getReadBackCount(CLSID& clsid,TYPE type) = 0;	//----获取读回复计数
	virtual ULONG getWriteCount(CLSID& clsid,TYPE type) = 0;	//----获取写计数
	virtual ULONG getWriteBackCount(CLSID& clsid,TYPE type) = 0;	//----获取写回复计数

	/**
	 * 获取设备列表
	 */
	virtual std::vector<Device* >& getDeviceList() = 0;	//----获取设备列表
};

#endif /* ACTION_DACONTROLERI_H_ */
