/**
 * @content:ParaAnalysisI接口定义头文件
 * @time:2016-8-25
 * @author:Mr_zhu
 * @version: V1.0
 * @describe:
 * 1#2016-8-23#V1.0#首次生成
 */

#ifndef INCLUDE_IPARAANALYSIS_H_
#define INCLUDE_IPARAANALYSIS_H_

#include <string>

#include "../common/IUnknown.h"
#include "../common/Type.h"

interface ParaAnalysisI: IUnknown
{

	enum DATATYPE
	{
		STRING = 0,
		INT,
		FLOAT,
		HEXINT,
		HEXFLOAT
	};

	/**
	 * 获取参数个数
	 */
	virtual ULONG getParaCount() = 0;

	/**
	 * 根据索引获取参数对
	 */
	virtual HRESULT getParam(const unsigned int index, std::string& key,
			std::string& value, DATATYPE& datatype) = 0;

	/**
	 * 设置参数字符串
	 */
	virtual HRESULT setParaString(const std::string para) = 0;

	virtual ~ParaAnalysisI()
	{
	}
};

#endif /* INCLUDE_IPARAANALYSIS_H_ */
