/*
 * Packet.h
 *
 *  Created on: 2016年11月10日
 *      Author: Mr_zhu
 *     Content: 
 */

#ifndef SERVICEMODEL_PACKET_H_
#define SERVICEMODEL_PACKET_H_

#include <vector>

#include "../common/Type.h"
#include "Base.h"
#include "Item.h"

class Device;

class Packet
{
public:
	Packet() :
			m_parent(NULL)
	{

	}
	virtual ~Packet()
	{
	}

	const CLSID& getClsid() const
	{
		return m_clsid;
	}

	void setClsid(const CLSID& clsid)
	{
		this->m_clsid = clsid;
	}

	const Device* getParent() const
	{
		return m_parent;
	}

	void setParent(Device* parent)
	{
		this->m_parent = parent;
	}

	std::vector<Item*>& getVitem()
	{
		return m_vitem;
	}

	void setVitem(const std::vector<Item*>& vitem)
	{
		this->m_vitem = vitem;
	}

	Base& getBase()
	{
		return m_base;
	}

	void setBase(const Base& base)
	{
		this->m_base = base;
	}

	HRESULT addItem(Item* item)
	{
		bool isexist = false;

		for (Item*& i : m_vitem)
		{
			if (i->isEqual(*item))
			{
				isexist = true;
				break;
			}
		}
		if (!isexist)
		{
			m_vitem.push_back(item);

			return S_OK;
		}
		return S_FALSE;
	}

	ULONG getItemCount()
	{
		return m_vitem.size();
	}

public:
	bool isEqual(Packet& packet)
	{
		bool bresult = true;

		if ((packet.getClsid() == m_clsid) && (packet.getParent() == m_parent))
		{
			return true;
		}
		else
		{
			bresult = false;
		}
		std::vector<Item*>& v = packet.getVitem();
		if (this->getItemCount() == packet.getItemCount())
		{
			for (unsigned int i = 0; i < m_vitem.size(); i++)
			{
				if (!(m_vitem.at(i)->isEqual(*(v.at(i)))))
				{
					bresult = false;
					break;
				}
			}
		}

		return bresult;
	}

	void outInfo()
	{

		log_d( "采集包ID: %s",
				m_base.getObjid().toString().c_str());
		log_d( "采集包名称: %s",
				m_base.getName().c_str());
		log_d( "采集包参数: ");
		for (std::pair<const std::string, std::string>& s : m_base.getParams())
		{
			log_d( "参数名称: %s, 参数值: %s",
					s.first.c_str(),s.second.c_str());
		}

		log_d( "采集包读写状态: %d", m_base.getRwstate());
		log_d( "采集包优先级: %d", m_base.getPriority());
		log_d( "采集包父句柄: %d", m_parent);

		log_d( "采集包总采集点数: %d", m_vitem.size());
		log_d( "采集包采集点信息: ");

		for (Item*& i : m_vitem)
		{
			i->outInfo();
		}
	}

private:
	CLSID m_clsid;
	Device* m_parent;
	std::vector<Item*> m_vitem;

	Base m_base;
};

#endif /* SERVICEMODEL_PACKET_H_ */
