/*
 * main.cpp
 *
 *  Created on: 2017年1月4日
 *      Author: nego
 */

#include <stddef.h>
#include <vector>

#include "../common/GUID.cpp"
#include "../common/Type.h"
#include "../externservice/DAControlerI.h"
#include "../servicemodel/Device.h"
#include "../util/impl/ClassLoaderImpl.h"

#include "../action/FaultRecorder.h"
#include "../action/impl/fault_filter.h"

class DataRecorderI;

int main()
{
	ClassLoaderI *pClass = new ClassLoaderImpl();
    //ProtocolImpl* pP = new ProtocolImpl();
    ProtocolI_Fault* pP = new ProtocolImpl();
    data_item *source = new data_item();
    data_item *fault = new data_item();
    std::string dev_name;
	DAControlerI *pDA;
	GUID guid = stringtoGUID("4140b836-5fe8-472b-a428-10e103b5016d");

	pClass->loadClass(IID_IDAControler, guid, (void**) &pDA);

	std::vector<Device*> ld;
    if (pDA != NULL)
    {
        pDA->init();
        pDA->start();
        ld = pDA->getDeviceList();

        if (ld.size() <= 0) {
            printf("ld.size is null\n", ld.size());
            delete pP;
            delete source;
            delete fault;
            delete pClass;
            return 0;
        }
    }


    pP->set_fault_list(ld);
	while (true)
	{
        #if 0
        if (ld.size() > 0)
        {
            source->source_pitem.clear();
            fault->fault_pitem.clear();
            source->number = 0;
            printf("ld.size() is %d\n", ld.size());
            for (int i = 0; i < ld.size(); ++i)
            {
                source->number += ld.at(i)->getVpacket().size();
                //设备名称
                dev_name = ld.at(i)->getBase().getName().c_str();
                //printf("i is %d, 设备名称为%s, count is %d\n", i, dev_name.c_str(), source->number);
                for(int j = 0; j < ld.at(i)->getVpacket().size(); ++j)
                {
                    Packet *t_ppacket = ld.at(i)->getVpacket().at(j);
                    //Device *ptdevice = (Device*) (t_ppacket->getParent());
                    if (t_ppacket == NULL)
                    {
                        printf("查找的包为空\n");
                        continue;
                    }

                    std::string t_sId, t_sname, t_svalue;
                    Base &t_base = t_ppacket->getVitem().at(0)->getBase();
                    t_sId = t_base.getObjid().toString().c_str();
                    t_sname = t_base.getName().c_str();
                    t_svalue = t_ppacket->getVitem().at(0)->getValue().c_str();
                    printf("t_sId is %s, t_sname is %s, t_svalue is %s\n", t_sId.c_str(), t_sname.c_str(), t_svalue.c_str());

                    // t_sId = t_base.getParam("功能码");
                    //int t_iId = 0;
                    //t_iId = strtol(t_sId.c_str(), NULL, HEX);   //----获取帧ID
                    //std::string forward_value = t_ppacket->getVitem()->getValue();

                    //保存故障滤波文件数据
                    printf("i is %d, 设备名称为%s, count is %d\n", i, dev_name.c_str(), source->number);
                    source->add_source_item(dev_name, t_sname, t_sId, t_svalue);
                }
            }
            //临时创建故障检测文件
            fault->number = 1;
            std::string test_value = "111";
            fault->add_fault_item("fault_test", "fault_test", test_value, test_value);
            if (!source) {
                printf("source is NULL\n");
            }
            if (!fault) {
                printf("fault is NULL\n");
            }
            pP->fault_filter(fault, source, 1, 2);
        }
        #endif
		secondsSleep(5);
	}

    delete pP;
    delete source;
    delete fault;
    delete pClass;

    return 0;

}

