/*
 * CodeConverter.h
 *
 *  Created on: 2017年4月21日
 *      Author: vsbes
 */

#ifndef UTIL_CODECONVERTER_H_
#define UTIL_CODECONVERTER_H_

#include <iconv.h>
#include <cstring>

// 代码转换操作类
class CodeConverter {
private:
	iconv_t cd;
public:
	// 构造
	CodeConverter(const char *from_charset, const char *to_charset) {
		cd = iconv_open(to_charset, from_charset);

		if((int )cd==-1){
			perror("cd ");
		}
	}

	// 析构
	~CodeConverter() {
		iconv_close(cd);
	}

	// 转换输出
	int convert(char *inbuf, int inlen, char *outbuf, int outlen) {
		char **pin = &inbuf;
		char **pout = &outbuf;

		memset(outbuf, 0, outlen);
		return iconv(cd, pin, (size_t *) &inlen, pout, (size_t *) &outlen);
	}
};

#endif /* UTIL_CODECONVERTER_H_ */
