/*
 * ClassLoader.cpp
 *
 *  Created on: 2016年11月7日
 *      Author: Mr_zhu
 *     Content: 
 */

#include "ClassLoaderImpl.h"

#include <dlfcn.h>
#include <stddef.h>
#include <iostream>

#include "../../common/GUID.cpp"
#include "../../externservice/SoCreateI.h"

using namespace std;

HRESULT ClassLoaderImpl::loadClass(const IID& iid, CLSID& clsid, void** pcmpnt)
{
	char* error;
	CreateFuncPTR CreateInstance;
	HRESULT t_result = S_FALSE;

	/**
	 * 打开创建组件的组件
	 */
	void* handle = dlopen("libsocreater.so", RTLD_LAZY);

	if (!handle)
	{
		log_e(
				"libsocreater.so打开失败,文件不存在或者存在错误, 错误码: %s", dlerror());
		return S_FALSE;
	}

	*(void**) (&CreateInstance) = dlsym(handle, "CreateInstance");
	if ((error = dlerror()) != NULL)
	{
		log_e( "创建CoCreate组件失败,错误码: %s", error);
		return S_FALSE;
	}
	IUnknown* pIUnknown = NULL;
	IUnknown* pICreateUnknown = NULL;

	pIUnknown = CreateInstance();
	if (pIUnknown == NULL)
	{
		log_e( "CoCreate接口调用失败");
		return S_FALSE;
	}

	CreateI* pICreate = NULL;
	HRESULT hr = pIUnknown->queryInterface(IID_ICreate, (void**) &pICreate);
	if (SUCCEEDED(hr))
	{
		log_d( "成功获取 创建组件的组件(CoCreate)接口");
		if ((pICreateUnknown = pICreate->callCreateInstance(clsid)) != NULL)
		{
			pICreateUnknown->queryInterface(iid, (void**) pcmpnt);
			pICreateUnknown->release();
		}
		else
		{
			log_e( "创建组件失败, 组件ID: %s",
					clsid.toString().c_str());
			return S_FALSE;
		}

		//pICreate->closeHandle();
		pICreate->release();
	}
	else
	{
		log_e( "获取 创建组件的组件(CoCreate)接口失败");
		return S_FALSE;
	}
	//pICreateUnknown->release();
	pICreateUnknown = NULL;

	pIUnknown->release();
	pIUnknown = NULL;

	dlclose(handle);

	if ((*pcmpnt) != NULL)
	{
		t_result = S_OK;
	}
	return t_result;
}

HRESULT ClassLoaderImpl::loadSqliteClass(void** pcmpnt)
{
	char* error;
	CreateFuncPTR CreateInstance;
	IUnknown* pIUnknown;
	HRESULT result = S_FALSE;

	void* handle = dlopen("libsqlitewrapper.so", RTLD_LAZY);
	if (!handle)
	{
		log_e(
				"libsqlitewrapper.so打开失败,文件不存在或者存在错误, 错误码: %s", dlerror());
		return S_FALSE;
	}

	*(void**) (&CreateInstance) = dlsym(handle, "CreateInstance");
	if ((error = dlerror()) != NULL)
	{
		log_e( "创建Sqlite3组件失败,错误码: %s", error);
		return S_FALSE;
	}
	pIUnknown = CreateInstance();
	if (pIUnknown == NULL)
	{
		log_e( "创建Sqlite3接口的接口调用失败");
		return S_FALSE;
	}
	HRESULT hr = pIUnknown->queryInterface(IID_ISqlite3, (void**) pcmpnt);

	if (SUCCEEDED(hr))
	{
		log_d( "成功获取 Sqlite3接口");
	}
	else
	{
		log_e( "获取Sqlite3接口失败");
		return S_FALSE;
	}

	pIUnknown->release();

	if ((*pcmpnt) != NULL)
	{
		result = S_OK;
	}

	return result;
}
